# AnnotatorDataView, generates view on Annotator ##Seg and ##Work files
#
# parameters: filename
#


import dbview,filez
import re,array


class AnnotatorDataView(dbview.View):

    # NOTE: Module name and class name should be identical (see View._getInstanceCode)
    # NOTE!!: This works for hg16, not for hg15!
    
    def createView(self, paramDict, parentViews, viewDB, id):
        super(AnnotatorDataView,self).createView(paramDict, parentViews, viewDB, id)
        # load actual data
        filename = paramDict['filename']
        lineno = 0
        try:
            handle = filez.open(filename,'r')
        except IOError:
            print "Warning: file ",filename," seems not to exist.  Proceeding with empty tab list."
            handle = []
        self.tablist = [ [], array.array('l'), array.array('l') ]
        for line in handle:
            lineno += 1
            if (line+"**")[:2] == '##':
                elts = line[:-1].split('\t')
                chrom = elts[1].strip()
                for seg in elts[2:]:
                    m = re.search("\(\s*(\d+)L?\s*,\s*(\d+)L?\s*\)",seg)
                    if m:
                        seg = (long(m.group(1)),long(m.group(2)))
                        self.tablist[0].append( chrom )
                        self.tablist[1].append( seg[0] )
                        self.tablist[2].append( seg[1] )
        try:
            handle.close()
        except AttributeError:
            # if file does not exist, handle is a list.  Continue silently
            pass
        # now cache them
        self.cacheList(self.tablist)


    def cacheList(self, list):
        list2 = list[:]
        for i in range(len(list2)):
            if type(list2[i]) == array.array:
                filename = self.getFileName("tablistarray") + "."+str(i)
                file = open(filename,"wb")
                list2[i].tofile( file )
                file.close()
                list2[i] = "ARRAY" + list[i].typecode
        self.cache( list2, "tablist" )


    def uncacheList(self):
        list2 = self.uncache( "tablist" )
        for i in range(len(list2)):
            if type(list2[i]) == str and list2[i] and list2[i][:-1] == "ARRAY":
                filename = self.getFileName("tablistarray") + "."+str(i)
                file = open(filename,"rb")
                list2[i] = array.array( list2[i][-1] )
                try:
                    list2[i].fromfile( file, 999999999 )
                except EOFError:
                    pass
                file.close()
        return list2


    def loadView(self, paramDict, parentViews, viewDB, id):
        self.tablist = self.uncacheList()


    def init(self):
        super(AnnotatorDataView,self).init()
        self.fields = {'chrom':0,'start':1,'end':2}


    def iter(self):
        self._idx = -1
        return self


    def next(self):
        self._idx += 1
        if self._idx < len(self.tablist[0]):
            return self.__getitem__(self._idx)
        raise StopIteration


    def __getitem__(self,key):
        return map( lambda x: x[key], self.tablist )
    

    def __len__(self):
        return self.tablist[0].__len__()

