# ChromosomeView, creates view on an entire chromosome (.fa files) via getSegment method


import dbview,filez


class ChromosomeView(dbview.View):

    # NOTE: Module name and class name should be identical (see View._getInstanceCode)
    
    def createView(self, paramDict, parentViews, viewDB, id):
        super(ChromosomeView,self).createView(paramDict, parentViews, viewDB, id)


    def loadView(self, paramDict, parentViews, viewDB, id):
        self.createView(paramDict, parentViews, viewDB, id)


    def init(self):
        super(ChromosomeView,self).init()
        self.file = filez.open(self.paramDict['filename'],'rb')
        self.chrom = self.file.readline()[1:-1]
        self.line0 = self.file.tell()
        self.numnucs = len(self.file.readline()[:-1])
        self.linelen = self.file.tell() - self.line0
        self.file.seek(0,2)
        totdata = self.file.tell() - self.line0
        self.lines = (totdata / self.linelen)
        self.totlen = self.lines * self.numnucs
        if totdata % self.linelen != 0:
            self.lines += 1
            self.totlen += totdata % self.linelen - self.linelen + self.numnucs
        

    def __del__(self):
        try:
            self.file.close()
        except:
            pass         # catch file-not-found initialisation


    def __getslice__(self,i,j):
        if 0 > i or j > self.totlen:
            raise IndexError, "Trying to access slice ["+str(i)+":"+str(j)+"], have [0:"+str(self.totlen)+"]"
        if i>=j:
            return ''
        startline = i/self.numnucs
        endline = (j-1)/self.numnucs
        leftover = (endline+1)*self.numnucs - j
        if leftover == 0:
            datalen = (endline-startline+1)*self.linelen
        else:
            datalen = (endline-startline+1)*self.linelen - self.linelen + self.numnucs - leftover
        self.file.seek(self.line0 + startline*self.linelen)
        return ''.join(self.file.read(datalen).splitlines())[i % self.numnucs:]


    def __len__(self):
        return self.totlen


